package com.czg.service.product.util;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONObject;
import com.czg.service.RedisService;
import jakarta.annotation.Resource;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * 微信公众号消息推送
 *
 * @author tankaikai
 * @since 2025-03-14 14:56
 */
@Data
@Slf4j
@Component
public class WxAccountUtil {

    @Value("${wx.ysk.appId}")
    private String appId = "wx212769170d2c6b2a";
    @Value("${wx.ysk.secrete}")
    private String secrete = "8492a7e8d55bbb1b57f5c8276ea1add0";
    @Value("${wx.ysk.operationMsgTmpId}")
    private String operationMsgTmpId;
    @Value("${wx.ysk.warnMsgTmpId}")
    private String warnMsgTmpId;

    @Resource
    @Lazy
    private RedisService redisService;

    static LinkedHashMap<String, String> linkedHashMap = new LinkedHashMap<>();

    static {
        linkedHashMap.put("40001", "获取 access_token 时 AppSecret 错误，或者 access_token 无效。请开发者认真比对 AppSecret 的正确性，或查看是否正在为恰当的公众号调用接口");
        linkedHashMap.put("40003", "不合法的 OpenID ，请开发者确认 OpenID （该用户）是否已关注公众号，或是否是其他公众号的 OpenID");
        linkedHashMap.put("40014", "不合法的 access_token ，请开发者认真比对 access_token 的有效性（如是否过期），或查看是否正在为恰当的公众号调用接口");
        linkedHashMap.put("40037", "不合法的 template_id");
        linkedHashMap.put("43101", "用户未订阅消息");
        linkedHashMap.put("43107", "订阅消息能力封禁");
        linkedHashMap.put("43108", "并发下发消息给同一个粉丝");
        linkedHashMap.put("45168", "命中敏感词");
        linkedHashMap.put("47003", "参数错误");
    }

    public String getAccessToken() {
        String accessToken = Convert.toStr(redisService.get("accessToken"));
        if (StrUtil.isNotEmpty(accessToken)) {
            return accessToken;
        }
        String resp = HttpUtil.get(StrUtil.format("https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid={}&secret={}", appId, secrete));
        JSONObject respInfo = JSONObject.parseObject(resp);
        if (!respInfo.containsKey("access_token")) {
            log.warn("公众号获取token失败, 响应内容: {}", resp);
            throw new RuntimeException(resp);
        }
        accessToken = respInfo.getString("access_token");
        int expiresIn = respInfo.getInteger("expires_in");
        redisService.set("accessToken", accessToken, expiresIn - 10);
        return accessToken;
    }

    public JSONObject sendTemplateMsg(String templateId, String toUserOpenId, Map<String, Object> data) {
        log.info("开始发送微信模板消息， 接收用户openId: {}, 消息数据: {}", toUserOpenId, data);
        String accessToken = getAccessToken();

        JSONObject object1 = new JSONObject();

        object1.put("template_id", templateId);
        object1.put("touser", toUserOpenId);
        object1.put("data", data);

        String response = HttpRequest.post("https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=".concat(accessToken)).body(object1.toString()).execute().body();
        log.info("微信模板消息发送成功，响应内容:{}", response);
        JSONObject resObj = JSONObject.parseObject(response);
        if (ObjectUtil.isNotEmpty(resObj) && ObjectUtil.isNotNull(resObj) && "0".equals(resObj.get("errcode") + "")) {
            return resObj;
        }

        throw new RuntimeException(linkedHashMap.getOrDefault(resObj.get("errcode") + "", "未知错误"));
    }

    public void sendOperationMsg(List<String> openIdList, String userName, String operationDesc) {
        openIdList.forEach(openId -> {
            Map<String, Object> data = new HashMap<String, Object>() {{
                put("thing19", new HashMap<String, Object>() {{
                    put("value", userName);
                }});
                put("thing8", new HashMap<String, Object>() {{
                    put("value", StrUtil.sub(operationDesc,0,20));
                }});
                put("time21", new HashMap<String, Object>() {{
                    put("value", DateUtil.format(DateUtil.date(), "yyyy-MM-dd HH:mm:ss"));
                }});
            }};
            log.info("开始发送敏感操作消息， 接收用户openId: {}, 操作用户: {}, 操作描述: {}", openId, userName, operationDesc);
            try {
                sendTemplateMsg(operationMsgTmpId, openId, data);
            } catch (Exception e) {
                log.error("发送失败, openId: {}, 响应: {}", openId, e.getMessage());
            }
        });
    }

    public void sendStockMsg(String shopName, String productName, BigDecimal stockNum, String openId) {
        String stockNumStr = stockNum.toPlainString();
        Map<String, Object> data = new HashMap<String, Object>() {{
            put("thing22", new HashMap<String, Object>() {{
                put("value", shopName);
            }});
            put("thing4", new HashMap<String, Object>() {{
                put("value", productName);
            }});
            put("number5", new HashMap<String, Object>() {{
                put("value", stockNumStr);
            }});
        }};
        log.info("开始发送库存预警消息， 接收用户openId: {}, 消息数据: {}", openId, data);
        try {
            sendTemplateMsg(warnMsgTmpId, openId, data);
        } catch (Exception e) {
            log.error("发送失败, openId:{}, msg: {}", openId, e.getMessage());
        }
    }

}
